using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace _01_Simple_Data_Binding
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtVendors;
		private System.Windows.Forms.Label lblVendors;
		private System.Windows.Forms.GroupBox grpSimple;
		private System.Windows.Forms.Label lblMyClass;
		private System.Windows.Forms.Button btnNext;
		private System.Windows.Forms.Button btnPrev;
		private System.Windows.Forms.GroupBox grpCustom;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtVendors = new System.Windows.Forms.TextBox();
			this.lblVendors = new System.Windows.Forms.Label();
			this.grpSimple = new System.Windows.Forms.GroupBox();
			this.grpCustom = new System.Windows.Forms.GroupBox();
			this.lblMyClass = new System.Windows.Forms.Label();
			this.btnNext = new System.Windows.Forms.Button();
			this.btnPrev = new System.Windows.Forms.Button();
			this.grpSimple.SuspendLayout();
			this.grpCustom.SuspendLayout();
			this.SuspendLayout();
			// 
			// txtVendors
			// 
			this.txtVendors.Enabled = false;
			this.txtVendors.Location = new System.Drawing.Point(32, 40);
			this.txtVendors.Name = "txtVendors";
			this.txtVendors.Size = new System.Drawing.Size(144, 20);
			this.txtVendors.TabIndex = 0;
			this.txtVendors.Text = "textBox1";
			// 
			// lblVendors
			// 
			this.lblVendors.Location = new System.Drawing.Point(32, 16);
			this.lblVendors.Name = "lblVendors";
			this.lblVendors.Size = new System.Drawing.Size(144, 24);
			this.lblVendors.TabIndex = 1;
			this.lblVendors.Text = "label1";
			// 
			// grpSimple
			// 
			this.grpSimple.Controls.Add(this.txtVendors);
			this.grpSimple.Controls.Add(this.lblVendors);
			this.grpSimple.Location = new System.Drawing.Point(8, 8);
			this.grpSimple.Name = "grpSimple";
			this.grpSimple.Size = new System.Drawing.Size(264, 72);
			this.grpSimple.TabIndex = 2;
			this.grpSimple.TabStop = false;
			this.grpSimple.Text = "Simple Binding To A Single Property";
			// 
			// grpCustom
			// 
			this.grpCustom.Controls.Add(this.lblMyClass);
			this.grpCustom.Location = new System.Drawing.Point(8, 88);
			this.grpCustom.Name = "grpCustom";
			this.grpCustom.Size = new System.Drawing.Size(264, 104);
			this.grpCustom.TabIndex = 3;
			this.grpCustom.TabStop = false;
			this.grpCustom.Text = "Simple Binding To User-Created Objects";
			// 
			// lblMyClass
			// 
			this.lblMyClass.Location = new System.Drawing.Point(24, 32);
			this.lblMyClass.Name = "lblMyClass";
			this.lblMyClass.Size = new System.Drawing.Size(176, 40);
			this.lblMyClass.TabIndex = 0;
			this.lblMyClass.Text = "label1";
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(8, 200);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(128, 56);
			this.btnNext.TabIndex = 4;
			this.btnNext.Text = "Next";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// btnPrev
			// 
			this.btnPrev.Location = new System.Drawing.Point(144, 200);
			this.btnPrev.Name = "btnPrev";
			this.btnPrev.Size = new System.Drawing.Size(128, 56);
			this.btnPrev.TabIndex = 5;
			this.btnPrev.Text = "Prev";
			this.btnPrev.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(288, 269);
			this.Controls.Add(this.btnPrev);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.grpCustom);
			this.Controls.Add(this.grpSimple);
			this.Name = "Form1";
			this.Text = "Simple Data Binding";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.grpSimple.ResumeLayout(false);
			this.grpCustom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		string[] vendorNames = { "Microsoft", "Apple", "Sun" };
		Food[] toEat;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			// Set up the first box
			txtVendors.DataBindings.Add("Text", vendorNames, "");
			lblVendors.DataBindings.Add("Text", vendorNames, "");

			// Set up the 
			toEat = new Food[2];
			toEat[0] = new Food("corn");
			toEat[1] = new Food("eggs");
			lblMyClass.DataBindings.Add("Text", toEat, "ACustomField");
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			// The BindingContext is associated with the GroupBox,
			// and serves to get the CurrencyManager for the 
			// DATA SOURCE, not the control being bound to it
			// (notice that we're using vendorNames, not lblVendors)
			grpSimple.BindingContext[vendorNames].Position -= 1;


			grpCustom.BindingContext[toEat].Position -= 1;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			// The BindingContext is associated with the GroupBox,
			// and serves to get the CurrencyManager for the 
			// DATA SOURCE, not the control being bound to it
			// (notice that we're using vendorNames, not lblVendors)
			grpSimple.BindingContext[vendorNames].Position += 1;


			grpCustom.BindingContext[toEat].Position += 1;
		}
	}



	class Food
	{
		public Food(string n)
		{
			strName = n;
		}

		private string strName;
		public string ACustomField
		{
			get
			{
				return strName;
			}
			set
			{
				strName = value;
			}
		}
	}
}
