using System;

namespace _03_Custom_Exceptions
{
	/// <summary>
	/// Summary description for NoncountingException.
	/// </summary>
	public class NoncountingNumberException : ApplicationException
	{
		double m_badNum = 0.0;
		bool m_badNumIsValid = false;

		public NoncountingNumberException() : base("", null)
		{
		}

		public NoncountingNumberException(String msg) : base (msg, null)
		{
		}
		public NoncountingNumberException(String msg, Exception innerExc) : base (msg, innerExc)
		{
		}
		
		// This constructor is used to initialize the badNum field
		// so that people can figure out exactly what the number is.
		public NoncountingNumberException(String msg, double offendingNumber): base ( msg+offendingNumber.ToString(), null)
		{
		}
		

		public bool hasBadNumber
		{
			get
			{
				return m_badNumIsValid;
			}
		}

		public double badNumber
		{
			get
			{
				if(m_badNumIsValid)
					return m_badNum;
				else
					// Note how we throw another exception, since this should never happen
					// Also, we save the current exception (using the "Me" reference - same as "this" in C++/C#)
					// for later use.
					throw new ApplicationException("Not allowed to get a number if there isn't a number already", this);
			}
			set
			{
				m_badNumIsValid = true;
				m_badNum = value;
			}
		}
	}
}






